/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FacebookLeadsControllerActionFormRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FacebookLeadsControllerActionFormRequest{}

// FacebookLeadsControllerActionFormRequest struct for FacebookLeadsControllerActionFormRequest
type FacebookLeadsControllerActionFormRequest struct {
	OAuthId *string `json:"oAuthId,omitempty"`
	PageId  *string `json:"pageId,omitempty"`
}

// NewFacebookLeadsControllerActionFormRequest instantiates a new FacebookLeadsControllerActionFormRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFacebookLeadsControllerActionFormRequest() *FacebookLeadsControllerActionFormRequest {
	this := FacebookLeadsControllerActionFormRequest{}
	return &this
}

// NewFacebookLeadsControllerActionFormRequestWithDefaults instantiates a new FacebookLeadsControllerActionFormRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFacebookLeadsControllerActionFormRequestWithDefaults() *FacebookLeadsControllerActionFormRequest {
	this := FacebookLeadsControllerActionFormRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *FacebookLeadsControllerActionFormRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookLeadsControllerActionFormRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *FacebookLeadsControllerActionFormRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *FacebookLeadsControllerActionFormRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetPageId returns the PageId field value if set, zero value otherwise.
func (o *FacebookLeadsControllerActionFormRequest) GetPageId() string {
	if o == nil || IsNil(o.PageId) {
		var ret string
		return ret
	}
	return *o.PageId
}

// GetPageIdOk returns a tuple with the PageId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookLeadsControllerActionFormRequest) GetPageIdOk() (*string, bool) {
	if o == nil || IsNil(o.PageId) {
		return nil, false
	}
	return o.PageId, true
}

// HasPageId returns a boolean if a field has been set.
func (o *FacebookLeadsControllerActionFormRequest) HasPageId() bool {
	if o != nil && !IsNil(o.PageId) {
		return true
	}

	return false
}

// SetPageId gets a reference to the given string and assigns it to the PageId field.
func (o *FacebookLeadsControllerActionFormRequest) SetPageId(v string) {
	o.PageId = &v
}

func (o FacebookLeadsControllerActionFormRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FacebookLeadsControllerActionFormRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.PageId) {
		toSerialize["pageId"] = o.PageId
	}
	return toSerialize, nil
}

type NullableFacebookLeadsControllerActionFormRequest struct {
	value *FacebookLeadsControllerActionFormRequest
	isSet bool
}

func (v NullableFacebookLeadsControllerActionFormRequest) Get() *FacebookLeadsControllerActionFormRequest {
	return v.value
}

func (v *NullableFacebookLeadsControllerActionFormRequest) Set(val *FacebookLeadsControllerActionFormRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableFacebookLeadsControllerActionFormRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableFacebookLeadsControllerActionFormRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFacebookLeadsControllerActionFormRequest(val *FacebookLeadsControllerActionFormRequest) *NullableFacebookLeadsControllerActionFormRequest {
	return &NullableFacebookLeadsControllerActionFormRequest{value: val, isSet: true}
}

func (v NullableFacebookLeadsControllerActionFormRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFacebookLeadsControllerActionFormRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
